/* import.c generated by valac 0.16.1, the Vala compiler
 * generated from import.vala, do not modify */

/*
 * FILE             $Id: $
 * DESCRIPTION      Importers from FreeMind, ...
 * PROJECT          Mind Map Architect
 * AUTHOR           Ondrej Tuma <mcbig@zeropage.cz>
 *
 * Copyright (C) Ondrej Tuma 2011
 * Code is present with BSD licence.
 */
/* modules: Gtk*/

#include <glib.h>
#include <glib-object.h>
#include <libxml/tree.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <gee.h>
#include <libxml/xmlreader.h>
#include <stdio.h>


#define TYPE_CORE_NODE (core_node_get_type ())
typedef struct _CoreNode CoreNode;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DIRECTION (direction_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _NodePrivate NodePrivate;

#define TYPE_MIND_MAP (mind_map_get_type ())
#define MIND_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIND_MAP, MindMap))
#define MIND_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIND_MAP, MindMapClass))
#define IS_MIND_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIND_MAP))
#define IS_MIND_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIND_MAP))
#define MIND_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIND_MAP, MindMapClass))

typedef struct _MindMap MindMap;
typedef struct _MindMapClass MindMapClass;
#define _xmlFreeTextReader0(var) ((var == NULL) ? NULL : (var = (xmlFreeTextReader (var), NULL)))

struct _CoreNode {
	gchar* title;
	guint direction;
	gboolean is_expand;
	gdouble points;
	gint function;
	gboolean default_color;
	GdkColor color;
};

typedef enum  {
	DIRECTION_LEFT,
	DIRECTION_RIGHT,
	DIRECTION_AUTO
} Direction;

struct _Node {
	GObject parent_instance;
	NodePrivate * priv;
	GdkDrawable* window;
	Node* parent;
	MindMap* map;
	GList* children;
	gchar* text;
	guint direction;
	gdouble weight;
	gdouble points;
	gint function;
	GdkColor color;
	GdkRectangle area;
	GdkRectangle full_left;
	GdkRectangle full_right;
	PangoFontDescription* font_desc;
	gboolean is_expand;
	gboolean visible;
	gboolean default_color;
	GeeHashSet* flags;
};

struct _NodeClass {
	GObjectClass parent_class;
};



GType core_node_get_type (void) G_GNUC_CONST;
CoreNode* core_node_dup (const CoreNode* self);
void core_node_free (CoreNode* self);
void core_node_copy (const CoreNode* self, CoreNode* dest);
void core_node_destroy (CoreNode* self);
void importer_read_mm_node_attr (xmlNode* x, CoreNode* c);
GType direction_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
void importer_read_mm_node (xmlNode* x, Node* n);
void core_node_init (CoreNode *self);
Node* node_add (Node* self, const gchar* title, guint direction, gboolean is_expand);
GType mind_map_get_type (void) G_GNUC_CONST;
gboolean importer_import_from_mm (const gchar* path, MindMap* mindmap);
Node* mind_map_create_new_root (MindMap* self, CoreNode* core);


static gboolean bool_parse (const gchar* str) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	g_return_val_if_fail (str != NULL, FALSE);
	_tmp0_ = str;
	if (g_strcmp0 (_tmp0_, "true") == 0) {
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}


void importer_read_mm_node_attr (xmlNode* x, CoreNode* c) {
	g_return_if_fail (c != NULL);
	{
		xmlNode* _tmp0_;
		xmlAttr* _tmp1_;
		xmlAttr* it;
		_tmp0_ = x;
		_tmp1_ = _tmp0_->properties;
		it = _tmp1_;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_;
				xmlAttr* _tmp6_;
				xmlAttr* _tmp7_;
				const gchar* _tmp8_;
				_tmp3_ = _tmp2_;
				if (!_tmp3_) {
					xmlAttr* _tmp4_;
					xmlAttr* _tmp5_;
					_tmp4_ = it;
					_tmp5_ = _tmp4_->next;
					it = _tmp5_;
				}
				_tmp2_ = FALSE;
				_tmp6_ = it;
				if (!(_tmp6_ != NULL)) {
					break;
				}
				_tmp7_ = it;
				_tmp8_ = _tmp7_->name;
				if (g_strcmp0 (_tmp8_, "TEXT") == 0) {
					xmlAttr* _tmp9_;
					xmlNode* _tmp10_;
					const gchar* _tmp11_;
					gchar* _tmp12_;
					_tmp9_ = it;
					_tmp10_ = _tmp9_->children;
					_tmp11_ = _tmp10_->content;
					_tmp12_ = g_strdup (_tmp11_);
					_g_free0 ((*c).title);
					(*c).title = _tmp12_;
				} else {
					xmlAttr* _tmp13_;
					const gchar* _tmp14_;
					_tmp13_ = it;
					_tmp14_ = _tmp13_->name;
					if (g_strcmp0 (_tmp14_, "POSITION") == 0) {
						Direction _tmp15_ = 0;
						xmlAttr* _tmp16_;
						xmlNode* _tmp17_;
						const gchar* _tmp18_;
						Direction _tmp19_;
						_tmp16_ = it;
						_tmp17_ = _tmp16_->children;
						_tmp18_ = _tmp17_->content;
						if (g_strcmp0 (_tmp18_, "right") == 0) {
							_tmp15_ = DIRECTION_RIGHT;
						} else {
							_tmp15_ = DIRECTION_LEFT;
						}
						_tmp19_ = _tmp15_;
						(*c).direction = (guint) _tmp19_;
					} else {
						xmlAttr* _tmp20_;
						const gchar* _tmp21_;
						_tmp20_ = it;
						_tmp21_ = _tmp20_->name;
						if (g_strcmp0 (_tmp21_, "FOLDED") == 0) {
							xmlAttr* _tmp22_;
							xmlNode* _tmp23_;
							const gchar* _tmp24_;
							gboolean _tmp25_ = FALSE;
							_tmp22_ = it;
							_tmp23_ = _tmp22_->children;
							_tmp24_ = _tmp23_->content;
							_tmp25_ = bool_parse (_tmp24_);
							(*c).is_expand = !_tmp25_;
						}
					}
				}
			}
		}
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


void importer_read_mm_node (xmlNode* x, Node* n) {
	g_return_if_fail (n != NULL);
	{
		xmlNode* _tmp0_;
		xmlNode* _tmp1_;
		xmlNode* it;
		_tmp0_ = x;
		_tmp1_ = _tmp0_->children;
		it = _tmp1_;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
			while (TRUE) {
				gboolean _tmp3_;
				xmlNode* _tmp6_;
				xmlNode* _tmp7_;
				xmlElementType _tmp8_;
				xmlNode* _tmp9_;
				const gchar* _tmp10_;
				_tmp3_ = _tmp2_;
				if (!_tmp3_) {
					xmlNode* _tmp4_;
					xmlNode* _tmp5_;
					_tmp4_ = it;
					_tmp5_ = _tmp4_->next;
					it = _tmp5_;
				}
				_tmp2_ = FALSE;
				_tmp6_ = it;
				if (!(_tmp6_ != NULL)) {
					break;
				}
				_tmp7_ = it;
				_tmp8_ = _tmp7_->type;
				if (_tmp8_ != XML_ELEMENT_NODE) {
					continue;
				}
				_tmp9_ = it;
				_tmp10_ = _tmp9_->name;
				if (g_strcmp0 (_tmp10_, "node") == 0) {
					CoreNode c = {0};
					xmlNode* _tmp11_;
					Node* _tmp12_;
					CoreNode _tmp13_;
					const gchar* _tmp14_;
					CoreNode _tmp15_;
					guint _tmp16_;
					CoreNode _tmp17_;
					gboolean _tmp18_;
					Node* _tmp19_ = NULL;
					Node* child;
					xmlNode* _tmp20_;
					Node* _tmp21_;
					core_node_init (&c);
					_tmp11_ = it;
					importer_read_mm_node_attr (_tmp11_, &c);
					_tmp12_ = n;
					_tmp13_ = c;
					_tmp14_ = _tmp13_.title;
					_tmp15_ = c;
					_tmp16_ = _tmp15_.direction;
					_tmp17_ = c;
					_tmp18_ = _tmp17_.is_expand;
					_tmp19_ = node_add (_tmp12_, _tmp14_, _tmp16_, _tmp18_);
					child = _tmp19_;
					_tmp20_ = it;
					_tmp21_ = child;
					importer_read_mm_node (_tmp20_, _tmp21_);
					_g_object_unref0 (child);
					core_node_destroy (&c);
				} else {
					xmlNode* _tmp22_;
					const gchar* _tmp23_;
					_tmp22_ = it;
					_tmp23_ = _tmp22_->name;
					if (g_strcmp0 (_tmp23_, "richcontent") == 0) {
						Node* _tmp24_;
						xmlNode* _tmp25_;
						gchar* _tmp26_ = NULL;
						gchar* _tmp27_;
						gchar* _tmp28_ = NULL;
						_tmp24_ = n;
						_tmp25_ = it;
						_tmp26_ = xmlNodeGetContent (_tmp25_);
						_tmp27_ = _tmp26_;
						_tmp28_ = string_strip (_tmp27_);
						_g_free0 (_tmp24_->text);
						_tmp24_->text = _tmp28_;
						_g_free0 (_tmp27_);
					}
				}
			}
		}
	}
}


gboolean importer_import_from_mm (const gchar* path, MindMap* mindmap) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	xmlTextReader* _tmp1_;
	xmlTextReader* r;
	xmlTextReader* _tmp2_;
	xmlTextReader* _tmp3_;
	xmlNode* _tmp4_ = NULL;
	xmlNode* x;
	xmlNode* _tmp5_;
	Node* root;
	Node* _tmp24_;
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (mindmap != NULL, FALSE);
	_tmp0_ = path;
	_tmp1_ = xmlNewTextReaderFilename (_tmp0_);
	r = _tmp1_;
	_tmp2_ = r;
	xmlTextReaderRead (_tmp2_);
	_tmp3_ = r;
	_tmp4_ = xmlTextReaderExpand (_tmp3_);
	x = _tmp4_;
	_tmp5_ = x;
	if (_tmp5_ == NULL) {
		FILE* _tmp6_;
		_tmp6_ = stderr;
		fprintf (_tmp6_, "The xml file node.xml is empty");
		result = FALSE;
		_xmlFreeTextReader0 (r);
		return result;
	}
	root = NULL;
	{
		xmlNode* _tmp7_;
		xmlNode* _tmp8_;
		xmlNode* it;
		_tmp7_ = x;
		_tmp8_ = _tmp7_->children;
		it = _tmp8_;
		{
			gboolean _tmp9_;
			_tmp9_ = TRUE;
			while (TRUE) {
				gboolean _tmp10_;
				xmlNode* _tmp13_;
				xmlNode* _tmp14_;
				xmlElementType _tmp15_;
				xmlNode* _tmp16_;
				const gchar* _tmp17_;
				_tmp10_ = _tmp9_;
				if (!_tmp10_) {
					xmlNode* _tmp11_;
					xmlNode* _tmp12_;
					_tmp11_ = it;
					_tmp12_ = _tmp11_->next;
					it = _tmp12_;
				}
				_tmp9_ = FALSE;
				_tmp13_ = it;
				if (!(_tmp13_ != NULL)) {
					break;
				}
				_tmp14_ = it;
				_tmp15_ = _tmp14_->type;
				if (_tmp15_ != XML_ELEMENT_NODE) {
					continue;
				}
				_tmp16_ = it;
				_tmp17_ = _tmp16_->name;
				if (g_strcmp0 (_tmp17_, "node") == 0) {
					CoreNode c = {0};
					xmlNode* _tmp18_;
					MindMap* _tmp19_;
					CoreNode _tmp20_;
					Node* _tmp21_ = NULL;
					xmlNode* _tmp22_;
					Node* _tmp23_;
					core_node_init (&c);
					_tmp18_ = it;
					importer_read_mm_node_attr (_tmp18_, &c);
					_tmp19_ = mindmap;
					_tmp20_ = c;
					_tmp21_ = mind_map_create_new_root (_tmp19_, &_tmp20_);
					_g_object_unref0 (root);
					root = _tmp21_;
					_tmp22_ = it;
					_tmp23_ = root;
					importer_read_mm_node (_tmp22_, _tmp23_);
					core_node_destroy (&c);
				}
			}
		}
	}
	_tmp24_ = root;
	result = _tmp24_ != NULL;
	_g_object_unref0 (root);
	_xmlFreeTextReader0 (r);
	return result;
}



